$files = null

describe "boco-markdown-driven", ->

  describe "Table of Contents", ->

  describe "Installation", ->

  describe "Overview", ->

  describe "Generators", ->

    describe "Available Generators", ->

    describe "Write a Generator", ->

  describe "Usage", ->
    [MarkdownDriven, MDDJasmineCoffee] = []

    beforeEach ->
      MarkdownDriven = require "boco-markdown-driven"
      MDDJasmineCoffee = require "boco-mdd-jasmine-coffee"

    describe "Using the API", ->
      [parser, generator, compiler] = []

      beforeEach ->
        parser = new MarkdownDriven.Parser nativeLanguages: ["coffee"]
        generator = new MDDJasmineCoffee.Generator
        
        compiler = new MarkdownDriven.Compiler
          parser: parser
          generator: generator
        compiler.compile "# Mather..." # => "describe 'Mather' -> ..."

    describe "Using the CLI", ->

      beforeEach ->
        $files = {
          "markdown-driven.json": "{\n  // require this generator\n  \"generator\": \"boco-mdd-jasmine-coffee\",\n\n  // marked lexer constructor options\n  // see: https://github.com/chjj/marked\n  \"lexerOptions\": {\n    \"gfm\": true\n  },\n\n  // parser constructor options\n  \"parserOptions\": {\n    \"nativeLanguages\": [\"coffee\"]\n  },\n\n  // generator constructor options\n  \"generatorOptions\": null,\n\n  // converter options\n  \"converterOptions\": {\n    \"readDir\": \"docs\",\n    \"writeDir\": \"spec\",\n    \"writeExt\": \".spec.coffee\"\n  }\n}\n"
        }

      afterEach ->
        $files = null
